divert(-1)

# Copyright (c) 2004 by Mark Kramer <admin@asarian-host.net>
#	All rights reserved.
# Copyright (c) 1988, 1993
#	The Regents of the University of California. All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
#

divert(0)

VERSIONID(`$Id: srs-socketmapd.m4,v 0.32rc3 2004/11/11 10:34:08 CEST mkramer Exp $')

ifdef(`_MAILER_DEFINED_',,`errprint(`*** WARNING: MAILER() should be before HACK(srs-socketmapd)')')

# Switches can be supplied or left off but if you supply any argument then the socket must be the first argument.

# Set socket location if supplied, if not then set default location

define(`SRS_SMSOCK', `local:/var/run/srs-socketmapd.sock')
ifelse(defn(`_ARG_'),`',,`define(`SRS_SMSOCK',_ARG_)')

LOCAL_CONFIG

# SRS socket maps

Kreverse_srs socket SRS_SMSOCK
Kmake_srs_all socket SRS_SMSOCK
Kmake_srs socket SRS_SMSOCK

# SRS regex map

Kis_srs regex ^<?SRS[01][-+=].*

ifdef(`SRS_EX_RCPT_DN', `
F{S}-o SRS_EX_RCPT_DN %[^\#]
')

MAILER_DEFINITIONS

SEnvFromSMTP

# forward srs rewrite
R$+		$: $>ForwardSrs $1

LOCAL_RULESETS

###################################################################
###  Local SRS Macros						###
###################################################################

SIsSrs
R$*				$: $(is_srs $1 $)
R$@				$@ YES
R$*				$@ NO

SReverseSrs
R$*				$: $1 $>IsSrs $1
R$* NO				$@ $1
R$* YES				$@ $(reverse_srs $1 $)

SSrsAddRcptDN
R$*				$@ $&h $| $1

SSrsAddSndrDN
R$* < @ $* >			$@ $2 $| $1 < @ $2 >

SSrsSelfSrs
R$* $| $*			$: $1 $| $(make_srs_all $2 $)
R$* $| $* < @ $* >		$@ $2 < @ $1 >

SForwardSrs
ifelse(lower(_ARG2_), `srs_non_local', `dnl
# Only rewrite non-local from addresse else skip srs
R$* < @ $=w > $*	$@ $1 < @ $2 > $3
R$* < @ $=w . > $*	$@ $1 < @ $2 . > $3
')dnl
ifdef(`SRS_EX_RCPT_DN', `dnl
# Skip srs forward rewrite if recipient DN is listed in class=S
R$*				$: $>SrsAddRcptDN $1
R$={S} $| $*			$@ $2
R$={S} . $| $*			$@ $2
R$* $| $*			$: $2
')dnl
ifelse(lower(_ARG2_), `srs_local_self', `dnl
# About to rewrite, if sender DN is in =w then self sign always
R$*				$: $>SrsAddSndrDN $1
R$=w $| $*			$@ $>SrsSelfSrs $1 $| $2
R$=w . $| $*			$@ $>SrsSelfSrs $1 $| $2
R$* $| $*			$: $2
')dnl
ifelse(lower(_ARG2_), `srs_all', `dnl
# Forward rewrite always even for alias domain
R$*				$: $(make_srs_all $1 $)
',`dnl
ifelse(lower(_ARG2_), `srs_local_self', `dnl
# Forward rewrite always even for alias domain
R$*				$: $(make_srs_all $1 $)
',`dnl
# Forward rewrite SRS default
R$*				$: $(make_srs $1 $)
')dnl
')dnl

LOCAL_RULE_0

# Do we need to reverse SRS address?

R$*				$: $>ReverseSrs $1
